# template.make If none of the provided machine/system match your
# hardware, than try copying this file into
# <machine>-<vendor>--<system>.make, edit it, and retry the building.
# The provided templates are named very precisely, although, they
# should work for a broader range of machines/systemes.


# Part one:
# ---------
# Command flags:
# INSTALL:
#    The install command on your system.
# RANLIB: 
#    Set this flag to the ranlib command on your system, or 'true' if
#    none is needed.
# ARFLAGS:
#    Flags to provide to the 'ar' command to create the oscheme
#    library.
# LDDYNFLAGS:
#    Flags to provide to the 'ld' command to create dynamically
#    loadable modules.
# CCDYNFLAGS:
#    Flags to provide to the 'cc' command to compile objects to be
#    included in dynamicaly loadable modules.
# CC:
#    Your C compiler 
# OPTIMIZE:
#    Optimizing flags (oscheme get a great speed-up when compiled with
#    the OPTIMIZE flag set to the most optimizing option of your
#    compiler - eg -O6 with gcc)
# DEFINES:
#    The list of specific defines for your systsem (see below)

     INSTALL = 
        MAKE = 
      RANLIB = 
     ARFLAGS = 
        SHLD = 
    SHCFLAGS = 
   SHLDFLAGS =
          CC = 
     DEFINES = 

# Part two:
# ---------
# Machine/System specific flags:
#
# A. Compiler flags:
# ------------------
# REGISTER (default 'register'):
#    Prefix keyword for local declaration, to make the local allocated
#    in a register.
# VOLATILE (default 'volatile'):
#    Prefix keyword for local declaration, to make them volatile.
# INLINE (default 'inline'):
#    Prefix keyword for functions to be inlined by the compiler. This
#    should really be set if it is possible.
# OS_STACK_GROWS (default 'OS_STACK_DOWN'):
#    The C stack growth direction. This can be either OS_STACK_DOWN,
#    or OS_STACK_UP.
# OS_HAS_PROTOTYPES (default undefine):
#    If your compiler supports ANSI prototype declarations.
#
# B. System flags:
# ----------------
#
# OS_PATH_SEPARATOR (default '/'):
#    The character to be used in file path names (eg '\' for dos)
# OS_PATH_HOME (default '~'):
#    The character to be used to express a home directory in a
#    path. Define this to '\0' if your system doesn't support
#    multiple users.
# OS_DEFAULT_PATH (default "~/oscheme:/usr/local/lib/oscheme"
#    Default oscheme load path (this can be overwritten either through OS_PATH
#    env variable, or wit hthe -path option.)
# OS_DEFAULT_EXTENSION (default ":.scm")
#    Default oscheme load extension (can be overwritten eith through 
#    OS_EXTENSION, or with -ext option.)
# OS_NEEDS_BCOPY (default undefine):
#    If your environment doesn't provide the bcopy functions, this
#    defines enable the use of memcpy instead.
# OS_HAS_SIGNALS (default undefine):
#    If your OS supports signals. In this case, you have the additional 
#    defines:
#        OS_REDECLARE_SIGNALS (default undefine): 
#            if signals should be restarted
#        OS_SIGNALS_MAX_PENDING (default 32): 
#            max # of pending signals
# OS_HAS_GETWD (default undefine):
#    If your system only provide this (broken) version of getcwd
# OS_HAS_RLIMIT (default undefine):
#    If your system supports the {set/get}rlimit calls (otherwise, the BSD
# OS_HAS_FORK (default undefine)
#    If your system doesn't provide the vfork (which is the default)
#    getdtablesize is used).
# OS_HAS_STRING_H (default undefine):
#    If <string.h> is to be used instead of <strings.h>
# OS_HAS_UNISTD_H (default undefine):
#    If your system have an unistd.h include file (for access(2))
# OS_HAS_SYSFILE_H (default undefine):
#    If your system requires sys/file.h to define F_OK
# OS_HAS_SYSDIR_H (default undefine):
#    If your system uses sys/dir.h instead of dirent.h
# OS_HAS_SYS_WAIT_H (default undefine):
#    If your system needs sys/wait.h to provide wait (2) facility. In this last
#    case, you might also define:
#        OS_HAS_WAIT3: in which case wait3 will be used whenever possible.
# OS_HAS_SYS_SELECT_H (default undefine):
#    If sys/select.h needs to be included to get select(2) definitions.
# OS_REGWIN_SIZE (default undefine):
#    Size of window register (# of rec calls, before copying the stack). On
#    sparc, defining this to 256 will be ok (too much secure !)
# OS_FLUSH_REGWIN_CODE (default undefine):
#    Define this symbol to the code to be emitted to flush register 
#    window. On sparc, for example: '-DOS_FLUSH_REGWIN_CODE=asm("t 0x3")'
# OS_HAS_DLD (default undefine):
#    This will a few subrs (see *dld.c), which allows to dynamically load in
#    object files.

# Part three:
# Optional kernel object files:
# If your machine supports dynamic loadable objects, it is time to declare the
# particular file that handles it:
# dld.c  for dlopen() interface
# gdld.c for gnu dynamic loading
# If some libc stuff is missing on your machine, you can add it here. Provided
# functions are:
# waitpid (waitpid.c)

OPTIONALS = 

# Part four:
# ----------
# Path customization

# Gc customization:
# Absolute path needed here !

      GC_DIR = 
 GC_INCLUDES = -I$(GC_DIR)
      GC_LIB = $(GC_DIR)/gc.a

# Dld customization 
# Absolute path needed here !

#     DLD_DIR = 
#DLD_INCLUDES = -I$(DLD_DIR)
#     DLD_LIB = -L$(DLD_DIR)

# Part five:
# ----------
# Installation parameters:

     OS_PREFIX = /usr/local
     OS_BINDIR = $(OS_PREFIX)/bin
  OS_MODULEDIR = $(OS_PREFIX)/lib/oscheme/modules
     OS_LIBDIR = $(OS_PREFIX)/lib/oscheme
    OS_HTMLDIR = $(OS_PREFIX)/lib/oscheme/html
 OS_SCRIPTSDIR = $(OS_PREFIX)/lib/oscheme/scripts

# OS_PREFIX:     Prefix for all installation directories
# OS_BINDIR:     The place to copy built executables 
# OS_MODULEDIR:  Where to put dynamically loadable modules
# OS_LIBDIR:     Where to put scheme libraries
# OS_HTMLDIR:    The place where to generate the HTML documentation
# OS_SCRIPTSDIR: The place where to copy scheme scripts