;; J-Jacques Girardot : 
;; for gscheme : increase stack size (MANDATORY !)
(stk-size 30000)
;; and add a few dozen cells (just to be comfortable - little influance in fact)
(gc-add-cell 80)



(define (succ n) (+ 1 n))

(define (mmap f) ; version 1
  (letrec ((map_rec (lambda (l) 
                      (cond ((null? l) '())
                            (else (cons (f (car l)) (map_rec (cdr l))))))))
    map_rec) )

(define (filter p l)
  (cond ((null? l) '())
        ((p (car l)) (cons (car l) (filter p (cdr l))))
        (else (filter p (cdr l)))))

(define (count from to)
  (if (> from to)
      '()
      (cons from (count (succ from) to))))

(define (concmap f l)
  (if (null? l)
      '()
      (append (f (car l)) (concmap f (cdr l)))))

(define (safe d x l)
   (if (null? l)
       #t
       (let ((q (car l)))
            (and (not (= x q))
                      (and (not (= x (+ q d)))
                           (and (not (= x (- q d)))
                                        (safe (+ d 1) x (cdr l))))))))

(define (ok l)
    (if (null? l)
        #t
        (safe 1 (car l) (cdr l))))

(define pos_l '())

(define (testcol b)
    (filter ok ((mmap (lambda (q) (cons q b))) pos_l)))

(define (gen n)
    (if (= n 0)
        '(())
        (let ((g (gen (- n 1))))
            (concmap testcol g))))


(define (nsoln nq)
    (set! pos_l (count 1 nq))
          (length (gen nq)))



