/***************************************************************************
 * os_dld.c
 * dld.c,v 1.2 1995/03/12 02:57:28 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * Sun (?) dl interface
 ***************************************************************************/

#include <stdio.h>
#include <setjmp.h>
#include <dlfcn.h>

#include <oscheme.h>

/*
 * Subrs
 */

static OsObject OsSubrDlLoad (OsString filename) {
    char initer[256] ;	/* BUG */
    void (*func)() ;
    void *handle ;
    OsString basename, full_path ;
    OsInterp interp = OsCurrentInterp() ;
    
    OsShouldBeString (filename) ;
    if ( ! (full_path = OsPathFindFile (interp, filename)) )
        return (OsA_False) ;
    basename = OsPathBasename (full_path) ;
    if ( ! (handle = dlopen (filename->string, 1)) ) {
        fprintf (stderr, "dlerror: %s\n", dlerror()) ;
        return (OsA_False) ;
    }
    sprintf (initer, "Os_%s_initialize", basename->string) ;
    if ( ! (func = (void (*)()) dlsym (handle, initer)) )
        return (OsA_False) ;
    (*func)(interp) ;
    return (OsA_True) ;
}

/*
 * Initialize :
 */

void OsDlInitialize (OsInterp interp, int *pargc, char **argv) {
    return ;
}

void OsDlSubrInitialize (OsInterp interp) {
    OsSubrMake (interp, "dl:load", OsSubrDlLoad, 1) ;
    OsPathProvides (interp, OsStringMake ("dld")) ;
    return ;
}
