/***************************************************************************
 * gcdalloc.c
 * gcdalloc.c,v 1.1.1.1 1995/02/27 15:15:43 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * Use this file instead of os_malloc.c if you want to purify oscheme. It
 * defines the memory management function to malloc (with no free), which
 * allows to find various memory errors.
 * All allocating functions should return 0-oed blocks.
 ***************************************************************************/

#include <stdio.h>
#include <setjmp.h>

#include <OsLib.h>

void *OsGCMalloc (unsigned int size) {
    void *p = malloc (size) ;
    if ( p ) {
        bzero (p, size) ;
        return (p) ;
    }
    OsError ("No more memory.") ;
    /* NOT REACHED */
}

void *OsGCRealloc (void *p, unsigned int size) {
    void *pp = realloc (p, size) ;
    if ( pp ) {
        return (pp) ;
    }
    OsError ("No more memory.") ;
    /* NOT REACHED */
}

void OsGCFree (void *p) {
    free (p) ;
    return ;
}
    
void *OsGCMallocAtomic (unsigned int size) {
    return (OsGCMalloc (size)) ;
}

void OsGCFreeAtomic (void *p) {
    free (p) ;
    return ;
}

void OsGCRegisterFinalizer (void *obj, void (*cfun)()) {
    /* Objects are never reclaimed, so no finalization is done */
    return ;
}
    
void *OsMalloc (unsigned int size) {
    return (OsGCMalloc (size)) ;
}

void OsFree (void *p) {
    free (p) ;
    return ;
}

char *OsGCStrdup (char *s) {
    return (strdup (s)) ;
}

int  OsGCExpandHeap (int count) {
    OsError ("OsGCExpandHeap: in no gc configuration.") ;
    /* NOT REACHED */
}

void OsSubrGCInitialize () {
    fprintf (stderr, "*** Running with no GC ***\n") ;
    return ;
}

    
