;; queen.scm
;; queen.scm,v 1.2 1995/03/07 02:21:19 baird Exp
;; See the file COPYRIGHT foe licensing conditions.
;; AUTODOC MODULE
;; The queen problem solved in oscheme. The most inefficient solution.

(define (debug . rst)
  (apply format (current-error-port) rst))

(define (succ n) (+ 1 n))

; (define (mmap f)
;   (letrec ((map_rec (lambda (l) 
;                       (cond ((null? l) '())
;                             (else (cons (f (car l)) (map_rec (cdr l))))))))
;     map_rec))

(define (mmap f)
  (define (map_rec l r)
    (cond ((null? l) (reverse r))
          (else (map_rec (cdr l) (cons (f (car l)) r)))))
  (lambda (l) (map_rec l ())))

; (define (filter p l)
;   (cond ((null? l) '())
;         ((p (car l)) (cons (car l) (filter p (cdr l))))
;         (else (filter p (cdr l)))))

(define (filter p l)
  (define (internal-filter p l r)
    (cond ((null? l) (reverse r))
          ((p (car l)) (internal-filter p (cdr l) (cons (car l) r)))
          (else (internal-filter p (cdr l) r))))
  (internal-filter p l ()))

; (define (count from to)
;   (if (> from to)
;       '()
;       (cons from (count (succ from) to))))

(define (count from to)
  (define (internal-count f t r)
    (if (> f t)
        (reverse r)
        (internal-count (succ f) t (cons f r))))
  (internal-count from to ()))

; (define (concmap f l)
;   (if (null? l)
;       '()
;       (append (f (car l)) (concmap f (cdr l)))))

(define (concmap f l)
  (define (internal-concmap f l r)
    (if (null? l)
        r
        (internal-concmap f (cdr l) (append r (f (car l))))))
  (internal-concmap f l (list)))

(define (nsoln nq)
  (letrec ((safe (lambda (d x l)
                   (if (null? l)
                       #t
                       (let ((q (car l)))
			 (and (not (= x q))
			      (and (not (= x (+ q d)))
				   (and (not (= x (- q d))) 
					(safe (+ d 1) x (cdr l)))))))))
           (ok (lambda (l)
                 (if (null? l) 
                     #t
                     (safe 1 (car l) (cdr l))))))
    (let ((pos_l (count 1 nq)))
      (letrec ((testcol (lambda (b) (filter ok ((mmap (lambda (q) (cons q b)))
                                                pos_l)))))
        (letrec ((gen (lambda (n)
                        (if (= n 0)
                            '(())
                            (let ((g (gen (- n 1))))
                              (concmap testcol g))))))
          (length (gen nq)))))))

