;;***************************************************************************
;; regexp.scm
;; regexp.scm,v 1.1.1.1 1995/02/27 15:16:08 baird Exp
;; See the file COPYRIGHT foe licensing conditions.
;; AUTODOC MODULE
;; Some regular expression goodies.
;***************************************************************************

;; AUTODOC AUTOLOAD
;; (regexp:match-one STRING RE-LIST)
;; Matches a string against a list of regular expressions.
;; The given string is matched against each regular expresssion in the given
;; list RE-LIST of regexp. The first match is returned.

(define (regexp:match-one str re-list)
  (and (pair? re-list)
       (or (regexp:match (car re-list) str)
           (regexp:match-one str (cdr re-list)))))

(provide "regexp")
