;; A simple raw benchmark !
;; tst.scm,v 1.1.1.1 1995/02/27 15:16:08 baird Exp
;; See the file COPYRIGHT foe licensing conditions.
;; AUTODOC MODULE
;; Various tests, do not try to understand them, they have been written to put
;; the virtual machine in some bug-specific situations.

(define (cond-fib n)
  (cond ((= n 0) 1)
        (( = n 1) 1)
        (else (+ (fib (- n 1)) (fib (- n 2))))))

(define (fib n)
  (if (< n 2) n (+ (fib (- n 1)) (fib (- n 2)))) )

(define (repeat n)
  (if (< n 0) n (begin (fib 20) (repeat (- n 1)))) )

;; tak:

(define (tak x y z)
  (if (not (< y x))
      z
      (tak (tak (- x 1) y z)
           (tak (- y 1) z x)
           (tak (- z 1) x y))))

;; closure & internal defines

(define tstclos
  (let ((n 0))
    (lambda (action . inc)
      (cond ((eq? action 'add) (set! n (+ n (car inc))) #t)
            ((eq? action 'sub) (set! n (- n (car inc))) #t)
            (else n)))) )

;; test tail call:

(define (loop2 ni nj)
  (let loopi ((i 0))
    (let loopj ((j 0))
      (if (< j nj) (loopj (+ 1 j))
          (if (< i ni) (loopi (+ 1 i)) (list i j))))) )

(define (loop3 ni nj nk)
  (let loopi ((i 0))
    (let loopj ((j 0))
      (let loopk ((k 0))
        (if (< k nk) 
            (begin (format (current-output-port) "%0 %1 %2\n" i j k)
                   (loopk (+ 1 k)))
            (if (< j nj) (loopj (+ 1 j))
                (if (< i ni) 
                    (loopi (+ 1 i))
                    (list i j k))))))))

(define (tst1 x) (define foo (let ((y 1)) (lambda (z) (+ z y x)))) (foo x))

(define (tst2 n)
  (define itst (let ((x 1)) (lambda (n) (+ x n))))
  (tst1 (itst n)))

(define (tst3 l)
  (define (f) 
    (map (lambda (s) (let ((p "x")) (display l) (path-append p s))) l))
  (f))

;;

(define (lodd? n)
  (if (= n 0) #f (leven? (- n 1))))

(define (leven? n)
  (if (= n 0) #t (lodd? (- n 1))))

;; IO

(define (dump-file file)
  (define (dump-current-input-port)
    (let loop ((line (read-line)))
      (and (not (eof-object? line))
           (display line) (newline)
           (loop (read-line)))))
  (with-input-from-file file dump-current-input-port) )

;; Test interference between dynamic-call and call/cc

(define (dynwin-test)
  (define cc ())
  (dynamic-wind 
   (lambda () (display "Enter.\n") (output-port-flush))
   (lambda (k) (display (call/cc (lambda (c) (set! cc c) (cc 1)))))
   (lambda () (display "After.\n") (output-port-flush)))
  cc )

(define (ddynwin-test)
  (define cc ())
  (dynamic-wind
   (lambda () (display "DEnter.\n") (output-port-flush))
   (lambda (k) (dynwin-test))
   (lambda () (display "DAfter.\n") (output-port-flush)))
  cc)

(provide "tst")

