;; tsteobj.scm
;; tsteobj.scm,v 1.1.1.1 1995/02/27 15:16:08 baird Exp
;; See the file COPYRIGHT foe licensing conditions.

;; TEST ONE:
;; Test class sharing, by creating a 'count' size family of oo

(define o [obj:root clone])
(define oo [o clone])

;; Create <count> "instances" of oo

(define (make-oo-instances count)
  (let loop ((c count) (il ()))
    (if (< c 0)
        il
        (loop (- c 1) (cons [oo clone] il)))))

;; TEST TWO:
;; Test structure modification propagations:

(define o [obj:root clone])
(define oo [o clone])
(define-message oo (display) (display "This is oo.\n") #t)

;; How to *share* a slot's value, in every clone, even if those clone do
;; assignemnet to it (ako class variable).

(define share-x-point
  (let ((point [obj:root clone]))
    [point defineSlot: "x" init: 0]
    [point defineSlot: "y" init: 0]
    ;; refine the clone method:
    (define-message point (display)
      (format (current-output-port) "@(%0, %1)" [self x] [self y]))
    (define-message point (clone)
      (let ((newpoint [[self super] clone]))
        (define-message newpoint (x: value) [[self prototype] x: value])
        newpoint))
    point))
  
