/***************************************************************************
 * os_arit.h
 * os_arit.h,v 1.2 1995/03/17 14:16:27 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * NOTE: integer are allocated as atomic objects. This makes ssens since
 * the only data available from ints are there classes, which is malloced
 * and not GCmalloced
 ***************************************************************************/

#ifndef _OS_NUMBER_H_
#define _OS_NUMBER_H_

/*
 * Integers:
 */

extern OsClass OsIntegerClass ;

#define OsIsInteger(i)		(((OsObject) (i))->os_class == OsIntegerClass)
#define OsMustBeInteger(i)	(OsMustBeOfClass((i), OsIntegerClass))
#define OsShouldBeInteger(i) \
    ((i) = (OsInteger) (OsMustBeOfClass((i), OsIntegerClass)))

#define OS_INTEGER_PREDEFINED_RANGE \
    (OS_HIGHEST_INTEGER_PREDEFINED - OS_LOWER_INTEGER_PREDEFINED)

typedef struct _OsInteger {
    OsClass os_class ;
    int     ival ;
} OsIntegerRec, *OsInteger ;

#define OsIntegerValue(i)	(((OsInteger) (i))->ival)

/*
 * Floats:
 */

extern OsClass OsFloatClass ;

#define OsIsFloat(f)		(((OsObject) (f))->os_class == OsFloatClass)
#define OsMustBeFloat(f)	(OsMustBeOfClass ((f), OsFloatClass))
#define OsShouldBeFloat(f) \
    ((f) = (OsFloat) (OsMustBeOfClass ((f), OsFloatClass)))

#define OsFloatIsZero(f)	(((OsFloat) (f))->fval == 0.0)
    
typedef struct _OsFloat {
    OsClass os_class ;
    double  fval ;
} OsFloatRec, *OsFloat ;

#define OsFloatValue(f)		(((OsFloat) (f))->fval)
    
/*
 * Externals:
 */

OsInteger OsIntegerMake OS_P ((int ival)) ;

void OsIntegerInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsIntegerSubrInitialize OS_P ((OsInterp interp)) ;

OsFloat   OsFloatMake OS_P ((double value)) ;
OsFloat   OsFloatMakeFromCString OS_P ((char *bytes)) ;

void OsFloatInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsFloatSubrInitialize OS_P ((OsInterp interp)) ;

#endif /* _OS_NUMBER_H_ */
