/***************************************************************************
 * os_atom.h
 * os_atom.h,v 1.1.1.1 1995/02/27 15:15:52 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_ATOM_H_
#define _OS_ATOM_H_

extern OsClass OsAtomClass ;

#define OsIsAtom(a)	(((OsObject)(a))->os_class == OsAtomClass)
#define OsMustBeAtom(a)	(OsMustBeOfClass((a), OsAtomClass))
#define OsShouldBeAtom(a) \
    ((a) = (OsAtom) OsMustBeOfClass ((a), OsAtomClass))

typedef struct _OsAtom {
    OsClass  os_class ;
    OsString pname ;
    OsObject vcell ;
} OsAtomRec, *OsAtom ;

/*
 * External declarations:
 */

extern OsObject OsA_Nil ;
extern OsObject OsA_False ;
extern OsObject OsA_True ;
extern OsObject OsA_Unbound ;
extern OsObject OsA_Quote ;
extern OsObject OsA_Quasiquote ;
extern OsObject OsA_Unquote ;
extern OsObject OsA_UnquoteSplice ;
extern OsObject OsA_Lambda ;

OsAtom OsAtomMake OS_P ((OsInterp interp
                         , char *name
                         , OsObject value)) ;
OsAtom OsAtomMakeWithString OS_P ((OsInterp interp
                                   , OsString pname
                                   , OsObject value)) ;
    
void   OsAtomInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void   OsAtomSubrInitialize OS_P ((OsInterp interp)) ;
    
#endif /* _OS_ATOM_H_ */
