/***************************************************************************
 * os_bcode.h
 * os_bcode.h,v 1.1.1.1 1995/02/27 15:15:52 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * Byte code description stuff. This should *not* be included elsewhere
 * than in the byte code decoder.
 ***************************************************************************/

typedef struct _bcode_descr {
    char          *name ;		/* instruction name */
    char 	  *fmt ;		/* arg format (as in byte stream) */
    unsigned int  skip ;		/* # of bytes to ghet to next instr */
} bcode_descr_rec, *bcode_descr ;

/*
 * fmt can be:
 * {<arg>}*
 * d: data index to scheme object
 * x: data index to code adress
 * g: code adress
 * n: constant (unsigned char)
 */

#ifdef OS_BYTECODE_DESCR_HERE
bcode_descr_rec byte_codes[] = {
/* 000 */ {"noop", "", 0},

/* 001 */ {"lref0", "n", 1}, 
/* 002 */ {"lref1", "n", 1},
/* 003 */ {"lref2", "n", 1},
/* 004 */ {"lref3", "n", 1},
/* 005 */ {"lrefn", "nn", 2}, 
/* 006 */ {"lref0push", "n", 1},
/* 007 */ {"lref1push", "n", 1},
/* 008 */ {"lref2push", "n", 1},
/* 009 */ {"lref3push", "n", 1},
/* 010 */ {"lrefnpush", "nn", 2},

/* 011 */ {"Unknown", "", 0},
/* 012 */ {"Unknown", "", 0},
/* 013 */ {"Unknown", "", 0},
/* 014 */ {"Unknown", "", 0},
/* 015 */ {"Unknown", "", 0},
/* 016 */ {"Unknown", "", 0},
/* 017 */ {"Unknown", "", 0},
/* 018 */ {"Unknown", "", 0},
/* 019 */ {"Unknown", "", 0},
/* 020 */ {"Unknown", "", 0},
/* 021 */ {"Unknown", "", 0},
/* 022 */ {"Unknown", "", 0},
/* 023 */ {"Unknown", "", 0},
/* 024 */ {"Unknown", "", 0},
/* 025 */ {"Unknown", "", 0},
/* 026 */ {"Unknown", "", 0},
/* 027 */ {"Unknown", "", 0},
/* 028 */ {"Unknown", "", 0},
/* 029 */ {"Unknown", "", 0},

/* 030 */ {"lset0", "n", 1},
/* 031 */ {"lset1", "n", 1},
/* 032 */ {"lset2", "n", 1},
/* 033 */ {"lset3", "n", 1},
/* 034 */ {"lsetn", "n", 1},

/* 035 */ {"Unknown", "", 0},
/* 036 */ {"Unknown", "", 0},
/* 037 */ {"Unknown", "", 0},
/* 038 */ {"Unknown", "", 0},
/* 039 */ {"Unknown", "", 0},
/* 040 */ {"Unknown", "", 0},
/* 041 */ {"Unknown", "", 0},
/* 042 */ {"Unknown", "", 0},
/* 043 */ {"Unknown", "", 0},
/* 044 */ {"Unknown", "", 0},
/* 045 */ {"Unknown", "", 0},
/* 046 */ {"Unknown", "", 0},
/* 047 */ {"Unknown", "", 0},
/* 048 */ {"Unknown", "", 0},
/* 049 */ {"Unknown", "", 0},

/* 050 */ {"gref", "d", 2},
/* 051 */ {"grefpush", "d", 2},
/* 052 */ {"gset", "d", 2},
/* 053 */ {"gdef", "d", 2},
          
/* 054 */ {"Unknown", "", 0},
/* 055 */ {"Unknown", "", 0},
/* 056 */ {"Unknown", "", 0},
/* 057 */ {"Unknown", "", 0},
/* 058 */ {"Unknown", "", 0},
/* 059 */ {"Unknown", "", 0},

/* 060 */ {"cst", "d", 2},
/* 061 */ {"cstpush", "d", 2},

/* 062 */ {"Unknown", "", 0},
/* 063 */ {"Unknown", "", 0},
/* 064 */ {"Unknown", "", 0},
/* 065 */ {"Unknown", "", 0},
/* 066 */ {"Unknown", "", 0},
/* 067 */ {"Unknown", "", 0},
/* 068 */ {"Unknown", "", 0},
/* 069 */ {"Unknown", "", 0},

/* 070 */ {"link", "d", 2},
/* 071 */ {"linkn", "d", 2},
/* 072 */ {"unlink", "n", 1},
/* 073 */ {"linkext", "d", 2},
/* 074 */ {"linknext", "d", 2},
/* 075 */ {"unlinkext", "n", 1},

/* 076 */ {"Unknown", "", 0},
/* 077 */ {"Unknown", "", 0},
/* 078 */ {"Unknown", "", 0},
/* 079 */ {"Unknown", "", 0},

/* 080 */ {"save", "g", 2},
/* 081 */ {"jump", "n", 1},
/* 082 */ {"unlinkjump", "nnn", 3},
/* 083 */ {"unlinkextjump", "nnn", 3},          
/* 084 */ {"return", "", 0},
/* 085 */ {"exit", "", 0},
/* 086 */ {"briffalse", "g", 2},
/* 087 */ {"briftrue", "g", 2},
/* 088 */ {"goto", "g", 2},
/* 089 */ {"savecont", "x", 2},
/* 090 */ {"retcont", "d", 2},
/* 091 */ {"savewind", "d", 2},
/* 092 */ {"retwind", "d", 2},

/* 093 */ {"Unknown", "", 0},
/* 094 */ {"Unknown", "", 0},
/* 095 */ {"Unknown", "", 0},
/* 096 */ {"Unknown", "", 0},
/* 097 */ {"Unknown", "", 0},
/* 098 */ {"Unknown", "", 0},
/* 099 */ {"Unknown", "", 0},

/* 100 */ {"push", "", 0},
/* 101 */ {"pop", "", 0},
/* 102 */ {"load", "n", 1},

/* 103 */ {"Unknown", "", 0},
/* 104 */ {"Unknown", "", 0},
/* 105 */ {"Unknown", "", 0},
/* 106 */ {"Unknown", "", 0},
/* 107 */ {"Unknown", "", 0},
/* 108 */ {"Unknown", "", 0},
/* 109 */ {"Unknown", "", 0},


/* 110 */ {"asubr0", "x", 2},
/* 111 */ {"asubr1", "x", 2},
/* 112 */ {"asubr2", "x", 2},
/* 113 */ {"asubr3", "x", 2},
/* 114 */ {"asubr4", "x", 2},
/* 115 */ {"asubr5", "x", 2},
/* 116 */ {"asubr6", "x", 2},
/* 117 */ {"asubr7", "x", 2},
/* 118 */ {"asubrn", "x", 2},

/* 119 */ {"Unknown", "", 0},
          
/* 120 */ {"subr0", "x", 2},
/* 121 */ {"subr1", "x", 2},
/* 122 */ {"subr2", "x", 2},
/* 123 */ {"subr3", "x", 2},
/* 124 */ {"subr4", "x", 2},
/* 125 */ {"subr5", "x", 2},
/* 126 */ {"subr6", "x", 2},
/* 127 */ {"subr7", "x", 2},
          
/* 128 */ {"Unknown", "", 0},
/* 129 */ {"Unknown", "", 0},

/* 130 */ {"close", "", 0},

/* 131 */ {"Unknown", "", 0},
/* 132 */ {"Unknown", "", 0},
/* 133 */ {"Unknown", "", 0},
/* 134 */ {"Unknown", "", 0},
/* 135 */ {"Unknown", "", 0},
/* 136 */ {"Unknown", "", 0},
/* 137 */ {"Unknown", "", 0},
/* 138 */ {"Unknown", "", 0},
/* 139 */ {"Unknown", "", 0},

/* 140 */ {"sendmsg0", "d", 2},
/* 141 */ {"sendmsg1", "d", 2},
/* 142 */ {"sendmsg2", "d", 2},
/* 143 */ {"sendmsg3", "d", 2},
/* 144 */ {"sendmsg4", "d", 2},
/* 145 */ {"sendmsg5", "d", 2},
/* 146 */ {"sendmsg6", "d", 2},
/* 147 */ {"sendmsg7", "d", 2},
/* 148 */ {"sendnmsg", "d", 2},

/* 149 */ {"Unknown", "", 0},

/* 150 */ {"sendsupermsg0", "d", 2}, 
/* 151 */ {"sendsupermsg1", "d", 2},         
/* 152 */ {"sendsupermsg2", "d", 2},        
/* 153 */ {"sendsupermsg3", "d", 2}, 
/* 154 */ {"sendsupermsg4", "d", 2}, 
/* 155 */ {"sendsupermsg5", "d", 2}, 
/* 156 */ {"sendsupermsg6", "d", 2}, 
/* 157 */ {"sendsupermsg7", "d", 2}, 
/* 158 */ {"sendsupernmsg", "d", 2},

/* 159 */ {"Unknown", "", 0},

/* 160 */ {"dbgpush", "d", 2},
/* 161 */ {"dbgpushbrk", "d", 2},
/* 162 */ {"dbgsafepush", "d", 2},
/* 163 */ {"dbgsafepushbrk", "d", 2},
/* 164 */ {"dbgpop", "", 0}

} ;

#else

extern bcode_descr_rec byte_codes[] ;

#endif /* OS_BYTECODE_DESCR_HERE */

