/***************************************************************************
 * os_cons.h
 * os_cons.h,v 1.3 1995/03/17 14:31:40 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_CONS_H_
#define _OS_CONS_H_

extern OsClass OsConsClass ;

#define OsIsCons(c)	(((OsObject) (c))->os_class == OsConsClass)
#define OsMustBeCons(c)	(OsMustBeOfClass ((c), OsConsClass))
#define OsShouldBeCons(c) \
    ((c) = (OsCons) OsMustBeOfClass ((c), OsConsClass))

typedef struct _OsCons {
    OsClass  os_class ;
    OsObject car ;
    OsObject cdr ;
} OsConsRec, *OsCons ;

#define OsConsCar(o)	(((OsCons) (o))->car)
#define OsConsCdr(o)	(((OsCons) (o))->cdr)
#define OsConsCaar(o)   (OsConsCar (OsConsCar (o)))
#define OsConsCadr(o)   (OsConsCar (OsConsCdr (o)))

#define OS_CONS_CAR(o)	(((OsCons) (o))->car)
#define OS_CONS_CDR(o)	(((OsCons) (o))->cdr)

/*
 * Externals:
 */

OsCons   OsConsMake OS_P ((OsObject car, OsObject cdr)) ;
OsCons   OsListNMake OS_P ((int size, OsObject *values)) ;
OsCons   OsList2Make OS_P ((OsObject o1, OsObject o2)) ;
OsCons   OsList2Append OS_P ((OsObject o1, OsObject o2, OsObject tail)) ;
OsCons   OsListCopy OS_P ((OsCons lst)) ;

unsigned int OsConsLength OS_P ((OsCons cons)) ;

void OsConsInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsConsSubrInitialize OS_P ((OsInterp interp)) ;
    
#endif /* _OS_CONS_H_ */
