/***************************************************************************
 * os_eobj.h
 * os_eobj.h,v 1.1.1.1 1995/02/27 15:15:53 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/


#ifndef _OS_EOBJ_H_
#define _OS_EOBJ_H_

/*
 * E(xteranl)Object scheme type:
 */

extern OsClass  OsEObjClass ;
extern OsObject OsEObjRoot ;

#define OsIsEObj(o)       (((OsObject) (o))->os_class == OsEObjClass)
#define OsMustBeEObj(o)   (OsMustBeOfClass ((o), OsEObjClass))
#define OsShouldBeEObj(o) \
    ((o) = (OsEObj) OsMustBeOfClass ((o), OsEObjClass))

typedef struct _os_iclass *os_iclass ;

typedef struct _OsEObj {
    OsClass        os_class ;		/* oscheme type */
    struct _OsEObj *prototype ;		/* father */
    os_iclass      objclass ;		/* ext obj implicit class */
    unsigned long  objclass_shl ;	/* shadow counter of objclass */
    OsVector       implements ;		/* implemented selector set */
    OsVector       readers, writers, values ;
} OsEObjRec, *OsEObj ;

/*
 * Selector scheme type:
 */

extern OsClass OsEObjSelClass ;

#define OsIsEObjSel(s)	   (((OsObject) (s))->os_class == OsEObjSelClass)
#define OsMustBeEObjSel(s) (OsMustBeOfClass((s), OsEObjSelClass))
#define OsShouldBeEObjSel(s) \
    ((s) = (OsEObjSel) OsMustBeOfClass ((s), OsEObjSelClass))

typedef unsigned short OsEObjSelId ;

typedef struct _OsEObjSel {
    OsClass        os_class ;
    unsigned short selc ;
    OsAtom         *selv ;
    unsigned short arity ;
    OsEObjSelId	   selid ;
} OsEObjSelRec, *OsEObjSel ;

/*
 * Selector implementation scheme type:
 */

typedef struct _os_selimp *os_selimp ;

extern OsClass OsEObjSelImpClass ;

#define OsIsEObjSelImp(s)     (((OsObject) (s))->os_class == OsEObjSelImpClass)
#define OsMustBeEObjSelImp(s) (OsMustBeOfClass ((s), OsEObjSelImpClass))
#define OsShouldBeEObjSelImp(s) \
    ((s) = (OsEObjSelImp) OsMustBeOfClass ((s), OsEObjSelImpClass))

typedef struct _OsEObjSelImp {
    OsClass   os_class ;
    OsEObj    from ;
    OsEObjSel sel ;
    os_selimp os_imp ;
} OsEObjSelImpRec, *OsEObjSelImp ;
    
/*
 * Prototypes:
 */

extern OsEObjSel OsEObjSelClone ;    

void OsEObjInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsEObjSubrInitialize OS_P ((OsInterp interp)) ;    

OsObject _OsEObjSend0 OS_P ((OsEObj l, OsEObj o, OsEObjSel s, os_selimp i));
OsObject _OsEObjSend1 OS_P ((OsEObj l, OsEObj o, OsEObjSel s, os_selimp i
                             , OsObject a1)) ;
OsObject _OsEObjSend2 OS_P ((OsEObj l, OsEObj o, OsEObjSel s, os_selimp i
                             , OsObject a1, OsObject a2)) ;
OsObject _OsEObjSend3 OS_P ((OsEObj l, OsEObj o, OsEObjSel s, os_selimp i
                             , OsObject a1, OsObject a2, OsObject a3)) ;
OsObject OsEObjPerformWithArray OS_P ((OsEObj rcv
                                       , OsEObjSel sel
                                       , unsigned int argc, OsObject *argv)) ;

OsEObjSel OsEObjSelDefine OS_P ((char *name)) ;
OsEObjSel OsEObjSelMake OS_P ((unsigned int selc
                               , OsAtom *selv
                               , unsigned int arity)) ;

void     OsEObjDefineFullMsg OS_P((OsEObj o, OsEObjSel s, void *selimp)) ;

void     OsEObjDefineMsg OS_P ((OsEObj object
                                , OsEObjSel selector
                                , OsObject (*f)()
                                , void *closure)) ;
void     OsEObjDefineOsMsg  OS_P ((OsEObj object
                                   , OsEObjSel selector
                                   , OsObject function)) ;
OsObject OsEObjAllocateSlot OS_P ((OsEObj self
                                   , OsEObjSel rsel, OsEObjSel wsel
                                   , OsObject value)) ;

/*
 * Macros:
 */

#define OsEObjSendMsg0(l,r,s) \
    _OsEObjSend0 ((l), (r), (s), (os_selimp) 0)
#define OsEObjSendMsg1(l,r,s,a1) \
    _OsEObjSend1 ((l), (r), (s), (os_selimp) 0, (a1))
#define OsEObjSendMsg2(l,r,s,a1,a2) \
    _OsEObjSend2 ((l), (r), (s), (os_selimp) 0, (a1), (a2))
#define OsEObjSendMsg3(l,r,s,a1,a2,a3) \
    _OsEObjSend3 ((l), (r), (s), (os_selimp) 0, (a1), (a2), (a3))

#define OsEObjSendImp0(l,r,s,i) \
    _OsEObjSend0 ((l), (r), (s), (i))
#define OsEObjSendImp1(l,r,s,i,a1) \
    _OsEObjSend1 ((l), (r), (s), (i), (a1))
#define OsEObjSendImp2(l,r,s,i,a1,a2) \
    _OsEObjSend2 ((l), (r), (s), (i), (a1), (a2))
#define OsEObjSendImp3(l,r,s,i,a1,a2,a3) \
    _OsEObjSend3 ((l), (r), (s), (i), (a1), (a2), (a3))
    
    
#endif /* _OS_EOBJ_H_ */
