/***************************************************************************
 * os_gc.h
 * os_gc.h,v 1.1.1.1 1995/02/27 15:15:05 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_MALLOC_H_
#define _OS_MALLOC_H_

#include <gc.h>

#ifndef OS_MACRO_GC_CALL 

void *OsGCMalloc (unsigned int size) ;
void *OsGCRealloc (void *p, unsigned int size) ;
void OsGCFree (void *p) ;
    
void *OsGCMallocAtomic (unsigned int size) ;
void OsGCFreeAtomic (void *p) ;

void OsGCRegisterFinalizer (void *obj, void (*cfun)()) ;
    
void *OsMalloc (unsigned int size) ;
void OsFree (void *p) ;

#else /* OS_MACRO_GC_CALL */

#define OsGCMalloc(s)		   ((void *) GC_MALLOC(s))
#define OsGCRealloc(p,s)	   ((void *) GC_REALLOC(p,s))
#define OsGCFree(p)	    	   ((void) GC_FREE (p))
#define OsGCRegisterFinalizer(o,f) GC_REGISTER_FINALIZER((o),(f),0,0,0)
#define OsGCMallocAtomic(s)	   ((void *) GC_MALLOC_ATOMIC(s))
#define OsGCFreeAtomic(p)	   ((void) GC_FREE(p))

#define OsMalloc(s)		   ((void *) malloc(s))
#define OsFree(p)		   ((void) free (p))
    
#endif /* OS_MACRO_GC_CALL */

char *OsGCStrdup (char *s) ;
int  OsGCExpandHeap (int count) ;

void OsGCInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsSubrGCInitialize OS_P ((OsInterp interp)) ;
    
#endif /* _OS_MALLOC_H_ */
