/***************************************************************************
 * os_ptr.h
 * os_ptr.h,v 1.1.1.1 1995/02/27 15:15:41 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_POINTER_H_
#define _OS_POINTER_H_

extern OsError OsE_InvalidPointer ;

extern OsClass OsPointerClass ;

#define OsIsPointer(p)	     (((OsObject) (p))->os_class == OsPointerClass)
#define OsMustBePointer(p)   (OsMustBeOfClass((p), OsPointerClass))
#define OsShouldBePointer(p) \
    ((p) = (OsPointer) OsMustBeOfClass((p), OsPointerClass))

#define OS_POINTER_INVALID	1	/* Invalid flag */
#define OS_POINTER_SHARED	2

typedef struct _OsPointer {
    OsClass	  os_class ;
    unsigned char flags ;
    void          *pointer ;
} OsPointerRec, *OsPointer ;

OsPointer OsSharedPointerMake (void *pointer) ;
OsPointer OsPointerMake (void *pointer) ;
    
#define OsPointerInvalidate(p) \
    (((OsPointer) (p))->flags |= OS_POINTER_INVALID)
#define OsPointerIsValid(p) \
    (! (((OsPointer) (p))->flags & OS_POINTER_INVALID) )
#define OsPointerDeref(p) \
    (OsPointerIsValid(p) \
     ? (((OsPointer) (p))->pointer) \
     : (void *) OsErrorTrigger (1, OsE_InvalidPointer, (p)))
    
void OsPointerInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsPointerSubrInitialize OS_P ((OsInterp interp)) ;

#endif /* _OS_POINTER_H_ */
