/***************************************************************************
 * os_string.h
 * os_string.h,v 1.2 1995/03/17 14:32:57 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * NOTE: strings are byte arrays. 'len' stands for the length of the byte
 * array, without the *always* existing trailing 0.
 * For example, "foo":
 *     string = 'f' 'o' 'o' '\0'
 *     len    = 3
 ***************************************************************************/

#ifndef _OS_STRING_H_
#define _OS_STRING_H_

extern OsClass OsStringClass ;

#define OsIsString(s)		(((OsObject) (s))->os_class == OsStringClass)
#define OsMustBeString(s)	(OsMustBeOfClass ((s), OsStringClass))
#define OsShouldBeString(s) \
    ((s) = (OsString) (OsMustBeOfClass((s), OsStringClass)))

typedef struct _OsString {
    OsClass 	  os_class ;
    unsigned int  len ;
    unsigned char *string ;
} OsStringRec, *OsString ;

#define OsStringLength(s)	(((OsString) (s))->len)
#define OsStringBytes(s)	(((OsString) (s))->string)

extern OsClass OsCharClass ;

#define OsIsChar(c)		(((OsObject) (c))->os_class == OsCharClass)
#define OsMustBeChar(c)		(OsMustBeOfClass((c), OsCharClass))
#define OsShouldBeChar(c) \
    ((c) = (OsChar) OsMustBeOfClass ((c), OsCharClass))

typedef struct _OsChar {
    OsClass 	  os_class ;
    unsigned char c ;
} OsCharRec, *OsChar ;

/*
 * External
 */

OsChar        OsCharMake OS_P ((unsigned char c)) ;

void OsCharInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;    
void OsCharSubrInitialize OS_P ((OsInterp interp)) ;

OsString      OsStringMake (unsigned char *cstring) ;
OsString      OsStringMakeFromBytes (unsigned int size, unsigned char *str) ;
unsigned long OsStringHash (OsString str) ;
int           OsStringCompare (OsString str1, OsString str2) ;
OsString      OsStringCAppend (OsString str, char *cstr) ;
OsString      OsStringCBytesAppend (OsString s, unsigned int l, char *b) ;
int           OsStringDepth (OsString string) ;
    
void OsStringInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsStringSubrInitialize OS_P ((OsInterp interp)) ;

#endif /* _OS_STRING_H_ */
