/***************************************************************************
 * os_subr.h
 * os_subr.h,v 1.1.1.1 1995/02/27 15:15:23 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_SUBR_H_
#define _OS_SUBR_H_

extern OsClass OsSubrClass ;

#define OsIsSubr(s)	    (((OsObject) (s))->os_class == OsSubrClass)
#define OsMustBeSubr(s)	    (OsMustBeOfClass ((s), OsSubrClass))
#define OsShouldBeSubr(s) \
    ((s) = (OsSubr) (OsMustBeOfClass ((s), OsSubrClass)))
    
typedef struct _OsSubr {
    OsClass  os_class ;
    OsObject (*cfun)() ;
    int      security ;
} OsSubrRec, *OsSubr ;

#define OS_NARY		-1

OsCodeBlock OsCodeBlockMakeForC OS_P((OsObject (*cfun)()
                                      , int arity
                                      , int security)) ;

OsObject    OsSecSubrMake OS_P ((OsInterp interp
                                 , char *cname
                                 , OsObject  (*cfun)()
                                 , int arity
                                 , int security)) ;

OsObject    OsSecContSubrMake OS_P ((OsInterp interp
                                     , char *cname
                                     , OsObject (*cfun)()
                                     , int arity
                                     , int security)) ;

#define OsSubrMake(_i,_n,_c,_a) \
    OsSecSubrMake (_i,_n,_c,_a,OS_SECURITY_LOWEST)
#define OsContSubrMake(_i,_n,_c,_a) \
    OsSecContSubrMake (_i,_n,_c,_a,OS_SECURITY_LOWEST)

void OsSubrInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;

#endif /* _OS_SUBR_H_ */
