/***************************************************************************
 * os_vector.h
 * os_vector.h,v 1.3 1995/03/17 14:32:58 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_VECTOR_H_
#define _OS_VECTOR_H_

extern OsClass OsVectorClass ;

#define OsIsVector(v)		(((OsObject) (v))->os_class == OsVectorClass)
#define OsMustBeVector(v)	(OsMustBeOfClass((v), OsVectorClass))
#define OsShouldBeVector(v) \
    ((v) = (OsVector) OsMustBeOfClass ((v), OsVectorClass))

typedef struct _OsVector {
    OsClass      os_class ;
    unsigned int csize ;
    unsigned int cmax ;
    OsObject     *cells ;
} OsVectorRec, *OsVector ;

#define OsVectorLength(v)	(((OsVector) (v))->csize)
#define OsVectorRef(v,i)	(((OsVector) (v))->cells[i])
#define OsVectorCells(v)	(((OsVector) (v))->cells)

/*
 * Externals:
 */

OsVector     OsVectorMake OS_P ((unsigned int cmax)) ;
OsVector     OsVectorNMakeWithDefault OS_P ((unsigned int size, OsObject def));
OsVector     OsVectorMakeFromArray OS_P ((unsigned int argc, OsObject *argv));
OsVector     OsVector1Make OS_P ((OsObject o1)) ;
OsVector     OsVector2Make OS_P ((OsObject o1, OsObject o2)) ;
OsVector     OsVector3Make OS_P ((OsObject o1, OsObject o2, OsObject o3)) ;
OsVector     OsWeakVectorMake OS_P ((unsigned int cmax)) ;
    
unsigned int OsVectorFastAppend OS_P ((OsVector v, OsObject object)) ;
int          OsVectorFastRemoveq OS_P ((OsVector v, OsObject object)) ;
int          OsVectorFastMemq OS_P ((OsVector v, OsObject object)) ;
OsVector     OsVectorFix OS_P ((OsVector vector)) ;
OsVector     OsVectorTail OS_P ((OsVector vector, unsigned int tail)) ;

void OsVectorInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsVectorSubrInitialize OS_P ((OsInterp interp)) ;
    
#endif /* _OS_VECTOR_H_ */
