/***************************************************************************
 * subr.c
 * subr.c,v 1.2 1995/03/12 02:58:41 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#include <stdio.h>
#include <setjmp.h>

#include <os_config.h>
#include <os_interp.h>
#include <os_obj.h>
#include <os_string.h>
#include <os_atom.h>
#include <os_vector.h>
#include <os_error.h>
#include <os_cons.h>
#include <os_cblock.h>
#include <os_subr.h>

static unsigned char subr_code[] = {
    OS_B_SUBR0, (unsigned char) 0, (unsigned char) 0, OS_B_RETURN
} ;

OsClass OsSubrClass = (OsClass) 0 ;

OsCodeBlock OsCodeBlockMakeForC (OsObject (*cfun)(), int arity, int security) {
    OsString      code = OsStringMakeFromBytes (4, subr_code) ;
    unsigned char *pc  = code->string ;
    OsSubr        subr = (OsSubr) OsObjectMake (OsSubrClass, 0) ;

    subr->cfun     = cfun ;
    subr->security = security ;
    switch (arity) {
      case 0:
        *pc++ = OS_B_ASUBR0 ; break ;
      case 1:
        *pc++ = OS_B_ASUBR1 ; break ;
      case 2:
        *pc++ = OS_B_ASUBR2 ; break ;
      case 3:
        *pc++ = OS_B_ASUBR3 ; break ;
      case 4:
        *pc++ = OS_B_ASUBR4 ; break ;
      case 5:
        *pc++ = OS_B_ASUBR5 ; break ;
      case 6:
        *pc++ = OS_B_ASUBR6 ; break ;
      case 7:
        *pc++ = OS_B_ASUBR7 ; break ;
      case OS_NARY:
        *pc++ = OS_B_ASUBRN ; break ;
      default:
        (void) OsErrorTrigger (1, OsE_Implementation
                               , OsStringMake ("OsCodeBlockMakeForC")
                               , OsStringMake ("invalid subr arity")) ;
    }
    OS_PUT_SHORT (pc, (unsigned short) 0) ;
    return (OsCodeBlockMake(code->string, 4, OsVector1Make ((OsObject) subr)));
}

OsCodeBlock OsContBlockMakeForC (OsObject (*cfun)(), int arity, int security) {
    unsigned char code[8], *pc = code ;
    OsSubr        subr = (OsSubr) OsObjectMake (OsSubrClass, 0) ;

    subr->cfun     = cfun ;
    subr->security = security ;
    *pc++ = OS_B_SAVECONT ;
    OS_PUT_SHORT (pc, (unsigned short) 0) ;
    *pc++ = OS_B_RETURN ;
    return (OsCodeBlockMake (code, pc-code, OsVector1Make ((OsObject) subr))) ;
}

OsCodeBlock OsWindBlockMakeForC (OsObject (*cfun)(), int arity, int security) {
    unsigned char code[8], *pc = code ;
    OsSubr        subr = (OsSubr) OsObjectMake (OsSubrClass, 0) ;
    
    if ( arity != 3 ) {
        (void) OsErrorTrigger (1, OsE_Implementation
                               , OsStringMake ("OsWindBlockMakeForC")
                               , OsStringMake ("arity is not 3")) ;
    }
    subr->cfun     = cfun ;
    subr->security = security ;
    *pc++ = OS_B_SAVEWIND ;
    OS_PUT_SHORT (pc, (unsigned short) 0) ;
    *pc++ = OS_B_RETURN ;
    return (OsCodeBlockMake (code, pc-code, OsVector1Make ((OsObject) subr))) ;
}
    
OsObject OsSecSubrMake (OsInterp interp
                        , char *cname
                        , OsObject (*cfun)()
                        , int arity
                        , int security) {
    OsCodeBlock block = OsCodeBlockMakeForC (cfun, arity, security) ;
    return ((OsObject) OsAtomMake (interp, cname, (OsObject) block)) ;
}

OsObject OsSecContSubrMake (OsInterp interp
                            , char *cname
                            , OsObject (*cfun)()
                            , int arity
                            , int security) {
    OsCodeBlock block = OsContBlockMakeForC (cfun, arity, security) ;
    return ((OsObject) OsAtomMake (interp, cname, (OsObject) block)) ;
}

/*
 * Initialize :
 */

void OsSubrInitialize (OsInterp interp, int *pargc, char **argv) {
    OsSubrClass = OsClassDeclare ("Subr", sizeof (OsSubrRec)) ;
    return ;
}
