;; edit-int.scm
;; edit-int.scm,v 1.3 1995/03/17 14:25:44 baird Exp
;; See the file COPYRIGHT for licensing conditions.
;; A simple motif integer editor.

(define make-int-editor 
  (let ((editor [obj:root clone]))
    [editor defineSlot: "min" init: 0]
    [editor defineSlot: "max" init: 10]
    [editor defineSlot: "step" init: 1]
    ;; Build a new integer editor
    (define-message editor (new: name parent: parent) 
      (let* ((new     [self clone])
             (factory [parent factory])
             (box     [factory rowColumn: name parent: parent])
             (down    [factory arrowButton: "down" parent: box])
             (text    [factory textField: "text" parent: box])
             (up      [factory arrowButton: "up" parent: box]))
        [box orientation: "horizontal"]
        [down arrowDirection: "ARROW_DOWN"]
        ;; External API:
        ;; (value) integer slot containing current value
        ;; (step) slot containing the current step
        ;; (min) and (max) contains the limits
        (define-message new (value)
          (string->integer [text value]))
        (define-message new (value: value)
          [text value: (integer->string value)])
        ;; Plug the buttons into the text:
        [up defineCallback: "activate"
            to: (lambda (w)
                  (let ((ival (+ [new value] [new step])))
                    (and (<= ival [new max]) [new value: ival])))]
        [down defineCallback: "activate"
              to: (lambda (w)
                    (let ((ival (- [new value] [new step])))
                      (and (>= ival [new min]) [new value: ival])))]
        [text defineCallback: "activate"
              to: (lambda (w)
                    (let ((ival [new value]))
                      (if (and (>= ival [new min]) (<= ival [new max]))
                          [new value: ival]
                          [w value: (integer->string [new value])])))]
        new))
    (lambda (name parent)
      [editor new: name parent: parent])) )

(provide "edit-int")
