;; form.scm
;; form.scm,v 1.1.1.1 1995/02/27 15:14:52 baird Exp
;; See the file COPYRIGHT for licensing conditions.
;; AUTODOC MODULE
;; A simple "form" manager, ala HTML...still being worked at...

;; AUTODOC AUTOLOAD
;; (make-form [ITEMS]*)
;; 

(define make-form
  (let ((form-prototype [obj:root clone]))
    [form-prototype defineSlot: "frame"]
    [form-prototype defineSlot: "factory"]
    ;; Utility functions:
    ;; (entry NAME LABEL CONDITION)
    (define (make-entry form name label condition)
      (let* ((entry [[form factory] rowColumn: "entry" parent: [form frame]])
             (label [[form factory] label: label parent: entry])
             (text  [[form factory] textField: "text" parent: entry]))
        [entry orientation: "HORIZONTAL"]))
    ;; (menu NAME (VALUES*) CONDITION)
    (define (make-menu form name values condition)
      (let ((menu [[form factory] optionMenu: "name" parent: [form frame]]))
        (for-each
         (lambda (value) [[form factory] pushButton: value parent: menu])
         values)))
    (lambda (factory description)
      (let* ((form  [form-prototype clone])
             (top   [factory form: "top" parent: [factory appToplevel]])
             (frame [factory rowColumn: "form" parent: top]))
        [frame orientation: "VERTICAL"]
        [form frame: frame]
        [form factory: factory]
        (let loop ((items description))
          (if (null? items)
              form
              (let ((item (car items)))
                (case (car item)
                  ((entry)  (apply make-entry form (cdr item)))
                  ((menu)   (apply make-menu form (cdr item)))
                  ((button) (apply make-button form (cdr item)))
                  (else (error "make-form: unkown ITEM %0" (car item))))
                (loop (cdr items)))))))) )

  
;; Testing stuff:

(define f (motif:make-factory (getenv "DISPLAY") "form" "Form"))
(define sample
  '((entry "name" "Name: " (lambda () #t))
    (entry "adress" "Adress: " (lambda () #t))
    (menu  "age" ("A" "B" "C") (lambda () #t))))

