/***************************************************************************
 * w3syms.c
 * w3syms.c,v 1.1.1.1 1995/02/27 15:14:57 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 * This filke defines all symbols that W3 lib needs to have defined in
 * order to be linked with...the bigger this file, the poorer my interface
 * with libWWW (!)
 ***************************************************************************/

#include <stdio.h>

#include "HText.h"
#include "HTUtils.h"
#include "HTString.h"
#include "HTStream.h"

static int verbose = 0 ;

/*
 * HText handling:
 */

struct _HText {
    unsigned long foo ;
} ;

HText *HText_new (anchor)
    HTParentAnchor *anchor ;
{
    static unsigned long count = 0 ;
    HText *self = (HText *) malloc (sizeof (*self)) ;
    self->foo = count++ ;
    return (self) ;
}

HText *HText_new2 (anchor, stream)
    HTParentAnchor *anchor ;
    HTStream       *stream ;
{
    return (HText_new (anchor)) ;
}

void HText_appendCharacter (text, c)
    HText *text ;
    char  c ;
{
    if ( verbose )
        fprintf (stderr, "HText_appendCharacter (0x%08x, %c)\n", text, c) ;
    return ;
}

void HText_appendText (text, str)
    HText       *text ;
    CONST char  *str ;
{
    if ( verbose )
        fprintf (stderr, "HText_appendText (0x%08x, %s)\n", text, str) ;
    return ;
}

void HText_appendParagraph (text)
    HText *text ;
{
    if ( verbose )
        fprintf (stderr, "HText_appendParagraph (x%08x)\n", text) ;
    return ;
}

void HText_appendImage (text, anc, alt, alignment, isMap)
    HText         *text ;
    HTChildAnchor *anc ;
    CONST char    *alt ;
    CONST char    *alignment ;
    BOOL          isMap ;
{
    if ( verbose )
        fprintf (stderr, "HText_appendImage (x%08x)\n", text) ;
    return ;

}

void HText_beginAnchor (text, anc)
    HText *text ;
    HTChildAnchor *anc ;
{
    if ( verbose )
        fprintf (stderr, "HText_beginAnchor (x%08x)\n", text) ;
    return ;
}

void HText_endAnchor (text)
    HText *text ;
{
    if ( verbose )
        fprintf (stderr, "HText_endAnchor (x%08x)\n", text) ;
    return ;
}

void HText_beginAppend (text)
    HText *text ;
{
    if ( verbose )
        fprintf (stderr, "HText_beginAppend (x%08x)\n", text) ;
    return ;
}

void HText_endAppend (text)
    HText *text ;
{
    if ( verbose )
        fprintf (stderr, "HText_endAppend (x%08x)\n", text) ;
    return ;
}

BOOL HText_selectAnchor (text, anchor)
    HText         *text ;
    HTChildAnchor *anchor ;
{
    if ( verbose )
        fprintf (stderr, "HText_selectAnchor (x%08x, x%08x)\n", text, anchor) ;
    return (NO) ;
}

BOOL HText_select (text)
    HText *text ;
{
    if ( verbose )
        fprintf (stderr, "HText_select (x%08x)\n", text) ;
    return (YES) ;
}

/*
 * Style sheet
 */

HTStyleSheet sheet = {"default.style", 0 } ;

HTStyleSheet *styleSheet = &sheet ;

void HText_setStyle (text, style)
    HText *text ;
    HTStyle *style ;
{
    if ( verbose )
        fprintf (stderr, "HText_setStyle (0x%08x, 0x%08x)\n", text, style) ;
    return ;
}

